cd "C:\Users\mcsam\Dropbox\passive_portfolio\benchmark"

*First part of index total return data from GFD
local j = 0
local files : dir "C:\Users\mcsam\Dropbox\passive_portfolio\benchmark\new" files "*.xlsx"
foreach file in `files' {
	display "`file'"
	import excel "C:\Users\mcsam\Dropbox\passive_portfolio\benchmark\new\\`file'", sheet("Data Information") firstrow clear
	rename *,lower
	keep name
	drop if name==""	
	local name=name[1]
	display "`name'"

	import excel "C:\Users\mcsam\Dropbox\passive_portfolio\benchmark\new\\`file'", sheet("Price Data") firstrow clear
	rename *,lower
	gen name="`name'"
	local j = `j'+1
	save pt`j',replace
}

use pt1,clear
forvalues k=2/`j'{
	append using pt`k'
}
merge m:1 name using newbenchmark
drop _merge
replace bench="S4G" if name=="S&P 400/Citigroup Growth Total Return Index (with GFD Extension)"
replace bench="S4V" if name=="S&P 400/Citigroup Value Total Return Index (with GFD Extension)"
replace bench="S6G" if name=="S&P 600/Citigroup Growth Total Return Index (with GFD Extension)"
replace bench="S6V" if name=="S&P 600/Citigroup Value Total Return Index (with GFD Extension)"
save benchrawtrnew,replace

*additional total return data from Refinitiv
use "$path\Dropbox\passive_portfolio\benchmark\tr_raw.dta",clear
keep A RUSSELL1000EODTOTRETURN RUSSELL1000EODVALUETOTR RUSSELL1000EODGROWTHTOT 
rename A date
drop if date==.
sort date
rename RUSSELL1000EODTOTRETURN r1
rename RUSSELL1000EODVALUETOTR r2
rename RUSSELL1000EODGROWTHTOT r3
reshape long r,i(date) j(idx)
gen index="R1" if idx==1
replace index="R1V" if idx==2
replace index="R1G" if idx==3
drop idx
save 1,replace

use "$path\Dropbox\passive_portfolio\benchmark\tr_raw.dta",clear
keep F RUSSELL2000EODTOTRETURN RUSSELL2000EODGROWTHTOT RUSSELL2000EODVALUETOTR 
rename F date
drop if date==.
sort date
rename RUSSELL2000EODTOTRETURN r1
rename RUSSELL2000EODVALUETOTR r2
rename RUSSELL2000EODGROWTHTOT r3
reshape long r,i(date) j(idx)
gen index="R2" if idx==1
replace index="R2V" if idx==2
replace index="R2G" if idx==3
drop idx
save 2,replace

use "$path\Dropbox\passive_portfolio\benchmark\tr_raw.dta",clear
keep K RUSSELL3000EODTOTRETURN RUSSELL3000EODGROWTHTOT RUSSELL3000EODVALUETOTR 
rename K date
drop if date==.
sort date
rename RUSSELL3000EODTOTRETURN r1
rename RUSSELL3000EODVALUETOTR r2
rename RUSSELL3000EODGROWTHTOT r3
reshape long r,i(date) j(idx)
gen index="R3" if idx==1
replace index="R3V" if idx==2
replace index="R3G" if idx==3
drop idx
save 3,replace

use "$path\Dropbox\passive_portfolio\benchmark\tr_raw.dta",clear
keep P RUSSELLMIDCAPEODTOTRETUR RUSSELLMIDCAPGROWTHEODTO RUSSELLMIDCAPVALUEEODTOT
gen v1=real(RUSSELLMIDCAPGROWTHEODTO)
gen v2=real(RUSSELLMIDCAPVALUEEODTOT)
drop RUSSELLMIDCAPGROWTHEODTO RUSSELLMIDCAPVALUEEODTOT
rename P date
drop if date==.
sort date
rename RUSSELLMIDCAPEODTOTRETUR r1
rename v2 r2
rename v1 r3
reshape long r,i(date) j(idx)
gen index="RM" if idx==1
replace index="RMV" if idx==2
replace index="RMG" if idx==3
drop idx
save 4,replace 

use "$path\Dropbox\passive_portfolio\benchmark\tr_raw.dta",clear
keep U SPMidCap400TOTRETURNIND 
rename U date
drop if date==.
gen index="S4"
rename SPMidCap400TOTRETURNIND r
save 5,replace

use "$path\Dropbox\passive_portfolio\benchmark\tr_raw.dta",clear
keep X SP500COMPOSITETOTRETURNI
rename X date
drop if date==.
gen index="S5"
gen r=real(SP500COMPOSITETOTRETURNI)
drop SP500COMPOSITETOTRETURNI
save 6,replace

use "$path\Dropbox\passive_portfolio\benchmark\tr_raw.dta",clear
keep AA SP500VALUETOTRETURNIND SP500GROWTHTOTRETURNIND
rename AA date
drop if date==.
rename SP500VALUETOTRETURNIND r1
rename SP500GROWTHTOTRETURNIND r2
reshape long r,i(date) j(idx)
gen index="S5V" if idx==1
replace index="S5G" if idx==2
drop idx
save 7,replace

use "$path\Dropbox\passive_portfolio\benchmark\tr_raw.dta",clear
keep AE SP600PRICEINDEX
rename AE date
drop if date==.
rename SP600 r
gen index="S6"
save 8,replace


use "$path\Dropbox\passive_portfolio\benchmark\tr_raw.dta",clear
keep AH WILSHIRE5000TOTALMARKETTOT
rename AH date
drop if date==.
rename WILSHIRE5000TOTALMARKETTOT r
gen index="W5"
save 9,replace

use "$path\Dropbox\passive_portfolio\benchmark\tr_raw.dta",clear
keep AK WILSHIRE4500COMPLETIONTOTR
rename AK date
drop if date==.
rename WIL r
gen index="W4"
save 10,replace

use 1,clear
forvalues j=2/10{
	append using `j'
}
drop if r==.
tab index
bysort index (date): gen totalreturn=(r-r[_n-1])/r[_n-1]
save totalreturndata,replace

*additional history for S&P 500 index from Global Financial Data
use sptrv2,clear
rename d date
/*keep last observation each quarter -- these are total return indices so that's why it works*/
gen yq=yq(year(date),quarter(date))
format yq %tq
bysort yq (date): keep if _n==_N
gen tr_alt=(close-close[_n-1])/close[_n-1]
drop if tr==.
gen index="S5"
keep index yq tr
rename index bench
rename tr_alt tr
save tms5fix,replace

use totalreturndata,clear
gen yq=yq(year(date),quarter(date))
format yq %tq
bysort index yq (date): keep if _n==_N
bysort index (yq): gen tr=(r-r[_n-1])/r[_n-1]
drop if tr==.
keep index yq tr
rename index bench
drop if bench=="S5"
append using tms5fix
save totalreturndata2,replace

*Put together all the total return data
use benchrawtrnew,clear
gen d=date(date,"MDY")
gen yq=yq(year(d),quarter(d))
format yq %tq
bysort bench yq (d): keep if _n==_N
bysort bench (yq): gen tr=(close-close[_n-1])/close[_n-1]
drop if tr==.
keep bench yq tr
rename tr tr_gfd
merge 1:1 bench yq using "C:\Users\mcsam\Dropbox\passive_portfolio\data\totalreturndata2"
gen tr_final=tr
replace tr_final=tr_gfd if tr_final==.
keep bench yq tr_final
rename tr_final tr
save "C:\Users\mcsam\Dropbox\passive_portfolio\data\totalreturndata3",replace
